# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .dto_responses_author_search_response_article_result import DtoResponsesAuthorSearchResponseArticleResult

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Cluster(pydantic.BaseModel):
    """
    The data model representing a single cluster of articles.
    """

    cluster_id: str = pydantic.Field(description="The unique identifier for the cluster.")
    cluster_size: int = pydantic.Field(description="The number of articles in the cluster.")
    articles: typing.List[DtoResponsesAuthorSearchResponseArticleResult] = pydantic.Field(
        description="A list of articles in the cluster."
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
