# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class FailedAggregationResponse(pydantic.BaseModel):
    """
    The response model for a failed `Aggregation count` request.
    """

    status: str = pydantic.Field(description="The status of the response, indicating no matches were found.")
    total_hits: int = pydantic.Field(
        description="The total number of articles matching the search criteria, always zero in this case."
    )
    page: int = pydantic.Field(description="The current page number of the results, always zero in this case.")
    total_pages: int = pydantic.Field(
        description="The total number of pages available for the given search criteria, always zero in this case."
    )
    page_size: int = pydantic.Field(description="The number of articles per page, always zero in this case.")
    user_input: typing.Dict[str, typing.Any] = pydantic.Field(description="The user input parameters for the search.")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
